USE <db_name,,AdventureWorks2012>;
GO


WITH process_order AS
(
SELECT ROW_NUMBER() OVER(ORDER BY (SUM(user_seeks) + SUM([user_scans]) + SUM([user_lookups]) + SUM([user_updates])) DESC) AS rn, [object_id], object_name(object_id) AS [the_table], (SUM(user_seeks) + SUM([user_scans]) + SUM([user_lookups]) + SUM([user_updates])) AS [total_io], SUM(user_seeks) AS sum_seeks, SUM([user_scans]) AS sum_scans, SUM([user_lookups]) AS sum_lookups, SUM([user_updates]) AS sum_updates
FROM sys.[dm_db_index_usage_stats]
WHERE db_name([database_id]) = '<db_name,,AdventureWorks2012>' 
--	AND [index_id] = 0
GROUP BY [object_id] 
) 

SELECT 
	PO.*, i.[object_id] AS foo,

SCHEMA_NAME(o.schema_id) AS [schema]
	, object_name(i.object_id ) AS [table]
    , p.rows
	, '--Begin ' + object_name(i.object_id ) + ' Migration'
		+ CHAR(13) + CHAR(9) + 'ALTER TABLE [' + SCHEMA_NAME(o.schema_id) + '].[' + object_name(i.object_id ) + '] ADD foo_id bigint NOT NULL IDENTITY (1, 1);' 
		+ CHAR(13) + CHAR(9) + 'CREATE CLUSTERED INDEX [CIX_FOO_' + object_name(i.object_id ) + '] ON [' + SCHEMA_NAME(o.schema_id) + '].[' + object_name(i.object_id ) + '] ([foo_id] ASC) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = ON, DROP_EXISTING = OFF, ONLINE = ON, MAXDOP = 4, FILLFACTOR = 95) ON [<filegoup,,USER_DATA>];' 
		+ CHAR(13) + CHAR(9) + 'DROP INDEX [CIX_FOO_' + object_name(i.object_id ) + '] ON [' + SCHEMA_NAME(o.schema_id) + '].[' + object_name(i.object_id ) + '] WITH ( ONLINE = ON );' 
		+ CHAR(13) + CHAR(9) + 'ALTER TABLE [' + SCHEMA_NAME(o.schema_id) + '].[' + object_name(i.object_id ) + '] DROP COLUMN foo_id;' 
		+ CHAR(13) + CHAR(13) AS [sql_command]
FROM sys.indexes i 
	INNER JOIN sys.objects o ON i.object_id = o.object_id
	INNER JOIN sys.filegroups f ON i.[data_space_id] = f.[data_space_id]
    INNER JOIN sys.partitions p ON i.object_id = p.object_id AND i.index_id = p.index_id
    LEFT JOIN 
		(
			SELECT DISTINCT AC.[object_id], AC.[name] AS [column_name]
			FROM sys.[all_columns] AC 
				INNER JOIN sys.types T
					ON [AC].[system_type_id] = [T].[system_type_id]
			WHERE (AC.[max_length] = (-1) OR T.[name] IN ('text', 'ntext', 'image'))
		) BLOBS ON o.[object_id] = [BLOBS].[object_id]
	LEFT JOIN process_order PO ON i.[object_id] = PO.[object_id]
WHERE i.type_desc = 'HEAP'
	AND f.[name] != '<filegoup,,USER_DATA>'
	AND o.[is_ms_shipped] = 0
	AND [BLOBS].[object_id] IS NULL
ORDER BY PO.rn, p.[rows] DESC, [schema], [table];
