--====================================================
--Summary by Wait Duration for CXPACKET Wait Details
--====================================================
SELECT  [oWT].[wait_type]
      , SUM([oWT].[wait_duration_ms]) AS active_wait_duration_sum
FROM sys.[dm_os_waiting_tasks] oWT 
WHERE [oWT].[session_id] IN  
	(
		SELECT distinct [session_id] FROM sys.[dm_os_waiting_tasks] WHERE [wait_type] = 'CXPACKET'
	)
AND [oWT].[wait_type] NOT IN
(	-- filter out additional irrelevant waits
				'BROKER_TASK_STOP', 'BROKER_RECEIVE_WAITFOR', 
				'BROKER_TO_FLUSH', 'BROKER_TRANSMITTER', 'CHECKPOINT_QUEUE', 
				'CHKPT', 'DISPATCHER_QUEUE_SEMAPHORE', 'CLR_AUTO_EVENT', 
				'CLR_MANUAL_EVENT','FT_IFTS_SCHEDULER_IDLE_WAIT', 'KSOURCE_WAKEUP', 
				'LAZYWRITER_SLEEP', 'LOGMGR_QUEUE', 'MISCELLANEOUS', 'ONDEMAND_TASK_QUEUE',
				'REQUEST_FOR_DEADLOCK_SEARCH', 'SLEEP_TASK', 'TRACEWRITE',
				'SQLTRACE_BUFFER_FLUSH', 'XE_DISPATCHER_WAIT', 'XE_TIMER_EVENT'
				, 'CXPACKET')
GROUP BY [oWT].[wait_type]
ORDER BY 2 DESC



--====================================================
--Summary by Resource
--====================================================
SELECT  [oWT].[session_id]
	, [oWT].[resource_address]
	, [oWT].[resource_description]
    , SUM([oWT].[wait_duration_ms]) AS active_wait_duration_sum
    , COUNT([oWT].[session_id]) AS thread_count
FROM sys.[dm_os_waiting_tasks] oWT 
WHERE [oWT].[session_id] IN  
	(
		SELECT distinct [session_id] FROM sys.[dm_os_waiting_tasks] WHERE [wait_type] = 'CXPACKET'
	)
AND [oWT].[wait_type] NOT IN
(	-- filter out additional irrelevant waits
				'BROKER_TASK_STOP', 'BROKER_RECEIVE_WAITFOR', 
				'BROKER_TO_FLUSH', 'BROKER_TRANSMITTER', 'CHECKPOINT_QUEUE', 
				'CHKPT', 'DISPATCHER_QUEUE_SEMAPHORE', 'CLR_AUTO_EVENT', 
				'CLR_MANUAL_EVENT','FT_IFTS_SCHEDULER_IDLE_WAIT', 'KSOURCE_WAKEUP', 
				'LAZYWRITER_SLEEP', 'LOGMGR_QUEUE', 'MISCELLANEOUS', 'ONDEMAND_TASK_QUEUE',
				'REQUEST_FOR_DEADLOCK_SEARCH', 'SLEEP_TASK', 'TRACEWRITE',
				'SQLTRACE_BUFFER_FLUSH', 'XE_DISPATCHER_WAIT', 'XE_TIMER_EVENT'
				, 'CXPACKET')
GROUP BY [oWT].[session_id]
	, [oWT].[resource_address]
	, [oWT].[resource_description]
ORDER BY 5 DESC
 


--====================================================
--Detail
--==================================================== 
SELECT [oWT].* 
FROM sys.[dm_os_waiting_tasks] oWT 
WHERE [oWT].[session_id] IN  
	(
		SELECT distinct [session_id] FROM sys.[dm_os_waiting_tasks] WHERE [wait_type] = 'CXPACKET'
	)
AND [oWT].[wait_type] NOT IN
(	-- filter out additional irrelevant waits
				'BROKER_TASK_STOP', 'BROKER_RECEIVE_WAITFOR', 
				'BROKER_TO_FLUSH', 'BROKER_TRANSMITTER', 'CHECKPOINT_QUEUE', 
				'CHKPT', 'DISPATCHER_QUEUE_SEMAPHORE', 'CLR_AUTO_EVENT', 
				'CLR_MANUAL_EVENT','FT_IFTS_SCHEDULER_IDLE_WAIT', 'KSOURCE_WAKEUP', 
				'LAZYWRITER_SLEEP', 'LOGMGR_QUEUE', 'MISCELLANEOUS', 'ONDEMAND_TASK_QUEUE',
				'REQUEST_FOR_DEADLOCK_SEARCH', 'SLEEP_TASK', 'TRACEWRITE',
				'SQLTRACE_BUFFER_FLUSH', 'XE_DISPATCHER_WAIT', 'XE_TIMER_EVENT'
				, 'CXPACKET')
 ORDER BY oWT.[wait_type]
 
 